#
# tlhIn'Sa' 1.0 beta
#
# Copyright (c) 1997, K'tohk <ktohk@tos.net>
# All Rights Reserved
#
# Images and graphics Copyright (c) 1997 Kavok <duker@wic.net>
# All Rights Reserved
#
#   This is a published work of K'tohk <ktohk@tos.net>
#   ("K'tohk").  Permission to redistribute may be
#   obtained upon prior written permission by K'tohk, and
#   provided that the following conditions are also met:
#
#      1. Redistributions of source code, including binary forms,
#         must retain the above copyright notice, this list of
#         conditions, and the following disclaimer.
#
#      2. Documentation and/or other materials provided with any
#         redistribution must contain the above copyright notice,
#         this list of conditions, and the following disclaimer.
#
#      3. All advertising materials mentioning features or use of
#         this software must display the following acknowledgement:
#
#              This product includes software developed by
#              the K'tohk <ktohk@tos.net> and other contributors.
#
#      4. Neither the name of K'tohk nor the names of other
#         contributors may be used to endorse or promote products
#         derived from this software without specific prior written
#         permission.
#
#   THIS SOFTWARE IS PROVIDED BY K'TOHK AND CONTRIBUTORS ``AS IS''.
#   THEREFORE, ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#   FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL K'TOHK
#   OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED, AND ON
#   ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
#   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
#   OF SUCH DAMAGE
#

proc error_box { win str } {
    set z [tk_messageBox -icon error -type ok -title "Error" \
	       -parent $win -message "$str"]
}

proc canvas_init {} {
    global size
    global x_fact
    global y_fact
    global xb_Gfencer
    global yb_Gfencer
    global xb_Gblockader
    global yb_Gblockader
    global xb_Glancer
    global yb_Glancer
    global xb_Gvanguard1
    global yb_Gvanguard1
    global xb_Gvanguard2
    global yb_Gvanguard2
    global xb_Gvanguard3
    global yb_Gvanguard3
    global xb_Gswift
    global yb_Gswift
    global xb_Gflyer1
    global yb_Gflyer1
    global xb_Gflyer2
    global yb_Gflyer2
    global xb_Ggoal
    global yb_Ggoal
    global xb_Yfencer
    global yb_Yfencer
    global xb_Yblockader
    global yb_Yblockader
    global xb_Ylancer
    global yb_Ylancer
    global xb_Yvanguard1
    global yb_Yvanguard1
    global xb_Yvanguard2
    global yb_Yvanguard2
    global xb_Yvanguard3
    global yb_Yvanguard3
    global xb_Yswift
    global yb_Yswift
    global xb_Yflyer1
    global yb_Yflyer1
    global xb_Yflyer2
    global yb_Yflyer2
    global xb_Ygoal
    global yb_Ygoal
    
    if { $size == "s" } {
	canvas .c -background black -width 640 -height 480 -bd 4
    } else {
	canvas .c -background black -width 800 -height 600 -bd 4
    }
    pack .c

    .c create image 0 0 -image Board -anchor nw

    if { $size == "s" } {
	set xb_Gfencer 8
	set yb_Gfencer 8
	set xb_Gblockader 56
	set yb_Gblockader 8
	set xb_Glancer 104
	set yb_Glancer 8
	set xb_Gvanguard1 152
	set yb_Gvanguard1 8
	set xb_Gvanguard2 200
	set yb_Gvanguard2 8
	set xb_Gvanguard3 248
	set yb_Gvanguard3 8
	set xb_Gswift 8
	set yb_Gswift 56
	set xb_Gflyer1 56
	set yb_Gflyer1 56
	set xb_Gflyer2 104
	set yb_Gflyer2 56
	set xb_Ggoal 152
	set yb_Ggoal 56

	set xb_Yfencer 360
	set yb_Yfencer 8
	set xb_Yblockader 404
	set yb_Yblockader 8
	set xb_Ylancer 456
	set yb_Ylancer 8
	set xb_Yvanguard1 504
	set yb_Yvanguard1 8
	set xb_Yvanguard2 552
	set yb_Yvanguard2 8
	set xb_Yvanguard3 600
	set yb_Yvanguard3 8
	set xb_Yswift 456
	set yb_Yswift 56
	set xb_Yflyer1 504
	set yb_Yflyer1 56
	set xb_Yflyer2 552
	set yb_Yflyer2 56
	set xb_Ygoal 600
	set yb_Ygoal 56
    } else {
	set xb_Gfencer 10
	set yb_Gfencer 10
	set xb_Gblockader 70
	set yb_Gblockader 10
	set xb_Glancer 130
	set yb_Glancer 10
	set xb_Gvanguard1 190
	set yb_Gvanguard1 10
	set xb_Gvanguard2 250
	set yb_Gvanguard2 10
	set xb_Gvanguard3 310
	set yb_Gvanguard3 10
	set xb_Gswift 10
	set yb_Gswift 70
	set xb_Gflyer1 70
	set yb_Gflyer1 70
	set xb_Gflyer2 130
	set yb_Gflyer2 70
	set xb_Ggoal 190
	set yb_Ggoal 70
	
	set xb_Yfencer 450
	set yb_Yfencer 10
	set xb_Yblockader 510
	set yb_Yblockader 10
	set xb_Ylancer 570
	set yb_Ylancer 10
	set xb_Yvanguard1 630
	set yb_Yvanguard1 10
	set xb_Yvanguard2 690
	set yb_Yvanguard2 10
	set xb_Yvanguard3 750
	set yb_Yvanguard3 10
	set xb_Yswift 570
	set yb_Yswift 70
	set xb_Yflyer1 630
	set yb_Yflyer1 70
	set xb_Yflyer2 690
	set yb_Yflyer2 70
	set xb_Ygoal 750
	set yb_Ygoal 70
    }

    # CREATE IMAGES
    .c create image $xb_Gfencer $yb_Gfencer -image Gfencer -anchor nw -tag Gfencer
    .c create image $xb_Gblockader $yb_Gblockader -image Gblockader -anchor nw -tag Gblockader
    .c create image $xb_Glancer $yb_Glancer -image Glancer -anchor nw -tag Glancer
    .c create image $xb_Gvanguard1 $yb_Gvanguard1 -image Gvanguard -anchor nw -tag Gvanguard1
    .c create image $xb_Gvanguard2 $yb_Gvanguard2 -image Gvanguard -anchor nw -tag Gvanguard2
    .c create image $xb_Gvanguard3 $yb_Gvanguard3 -image Gvanguard -anchor nw -tag Gvanguard3
    .c create image $xb_Gswift $yb_Gswift -image Gswift -anchor nw -tag Gswift
    .c create image $xb_Gflyer1 $yb_Gflyer1 -image Gflyer -anchor nw -tag Gflyer1
    .c create image $xb_Gflyer2 $yb_Gflyer2 -image Gflyer -anchor nw -tag Gflyer2
    .c create image $xb_Ggoal $yb_Ggoal -image Ggoal -anchor nw -tag Ggoal

    .c create image $xb_Yfencer $yb_Yfencer -image Yfencer -anchor nw -tag Yfencer
    .c create image $xb_Yblockader $yb_Yblockader -image Yblockader -anchor nw -tag Yblockader
    .c create image $xb_Ylancer $yb_Ylancer -image Ylancer -anchor nw -tag Ylancer
    .c create image $xb_Yvanguard1 $yb_Yvanguard1 -image Yvanguard -anchor nw -tag Yvanguard1
    .c create image $xb_Yvanguard2 $yb_Yvanguard2 -image Yvanguard -anchor nw -tag Yvanguard2
    .c create image $xb_Yvanguard3 $yb_Yvanguard3 -image Yvanguard -anchor nw -tag Yvanguard3
    .c create image $xb_Yswift $yb_Yswift -image Yswift -anchor nw -tag Yswift
    .c create image $xb_Yflyer1 $yb_Yflyer1 -image Yflyer -anchor nw -tag Yflyer1
    .c create image $xb_Yflyer2 $yb_Yflyer2 -image Yflyer -anchor nw -tag Yflyer2
    .c create image $xb_Ygoal $yb_Ygoal -image Ygoal -anchor nw -tag Ygoal

    .c bind Gfencer <Button-1> { canvas_mark "Gfencer" %x %y %W }    
    .c bind Gblockader <Button-1> { canvas_mark "Gblockader" %x %y %W }    
    .c bind Glancer <Button-1> { canvas_mark "Glancer" %x %y %W }    
    .c bind Gvanguard1 <Button-1> { canvas_mark "Gvanguard1" %x %y %W }    
    .c bind Gvanguard2 <Button-1> { canvas_mark "Gvanguard2" %x %y %W }    
    .c bind Gvanguard3 <Button-1> { canvas_mark "Gvanguard3" %x %y %W }    
    .c bind Gswift <Button-1> { canvas_mark "Gswift" %x %y %W }    
    .c bind Gflyer1 <Button-1> { canvas_mark "Gflyer1" %x %y %W }    
    .c bind Gflyer2 <Button-1> { canvas_mark "Gflyer2" %x %y %W }    
    .c bind Ggoal <Button-1> { canvas_mark "Ggoal" %x %y %W }    

    .c bind Yfencer <Button-1> { canvas_mark "Yfencer" %x %y %W }    
    .c bind Yblockader <Button-1> { canvas_mark "Yblockader" %x %y %W }    
    .c bind Ylancer <Button-1> { canvas_mark "Ylancer" %x %y %W }    
    .c bind Yvanguard1 <Button-1> { canvas_mark "Yvanguard1" %x %y %W }    
    .c bind Yvanguard2 <Button-1> { canvas_mark "Yvanguard2" %x %y %W }    
    .c bind Yvanguard3 <Button-1> { canvas_mark "Yvanguard3" %x %y %W }    
    .c bind Yswift <Button-1> { canvas_mark "Yswift" %x %y %W }    
    .c bind Yflyer1 <Button-1> { canvas_mark "Yflyer1" %x %y %W }    
    .c bind Yflyer2 <Button-1> { canvas_mark "Yflyer2" %x %y %W }    
    .c bind Ygoal <Button-1> { canvas_mark "Ygoal" %x %y %W }    

    .c bind Gfencer <B1-Motion> { canvas_drag "Gfencer" %x %y %W }
    .c bind Gblockader <B1-Motion> { canvas_drag "Gblockader" %x %y %W }
    .c bind Glancer <B1-Motion> { canvas_drag "Glancer" %x %y %W }
    .c bind Gvanguard1 <B1-Motion> { canvas_drag "Gvanguard1" %x %y %W }
    .c bind Gvanguard2 <B1-Motion> { canvas_drag "Gvanguard2" %x %y %W }
    .c bind Gvanguard3 <B1-Motion> { canvas_drag "Gvanguard3" %x %y %W }
    .c bind Gswift <B1-Motion> { canvas_drag "Gswift" %x %y %W }
    .c bind Gflyer1 <B1-Motion> { canvas_drag "Gflyer1" %x %y %W }
    .c bind Gflyer2 <B1-Motion> { canvas_drag "Gflyer2" %x %y %W }
    .c bind Ggoal <B1-Motion> { canvas_drag "Ggoal" %x %y %W }

    .c bind Yfencer <B1-Motion> { canvas_drag "Yfencer" %x %y %W }
    .c bind Yblockader <B1-Motion> { canvas_drag "Yblockader" %x %y %W }
    .c bind Ylancer <B1-Motion> { canvas_drag "Ylancer" %x %y %W }
    .c bind Yvanguard1 <B1-Motion> { canvas_drag "Yvanguard1" %x %y %W }
    .c bind Yvanguard2 <B1-Motion> { canvas_drag "Yvanguard2" %x %y %W }
    .c bind Yvanguard3 <B1-Motion> { canvas_drag "Yvanguard3" %x %y %W }
    .c bind Yswift <B1-Motion> { canvas_drag "Yswift" %x %y %W }
    .c bind Yflyer1 <B1-Motion> { canvas_drag "Yflyer1" %x %y %W }
    .c bind Yflyer2 <B1-Motion> { canvas_drag "Yflyer2" %x %y %W }
    .c bind Ygoal <B1-Motion> { canvas_drag "Ygoal" %x %y %W }
}

proc canvas_reinit {} {
    global x_fact
    global y_fact
    global xb_Gfencer
    global yb_Gfencer
    global xb_Gblockader
    global yb_Gblockader
    global xb_Glancer
    global yb_Glancer
    global xb_Gvanguard1
    global yb_Gvanguard1
    global xb_Gvanguard2
    global yb_Gvanguard2
    global xb_Gvanguard3
    global yb_Gvanguard3
    global xb_Gswift
    global yb_Gswift
    global xb_Gflyer1
    global yb_Gflyer1
    global xb_Gflyer2
    global yb_Gflyer2
    global xb_Ggoal
    global yb_Ggoal
    global xb_Yfencer
    global yb_Yfencer
    global xb_Yblockader
    global yb_Yblockader
    global xb_Ylancer
    global yb_Ylancer
    global xb_Yvanguard1
    global yb_Yvanguard1
    global xb_Yvanguard2
    global yb_Yvanguard2
    global xb_Yvanguard3
    global yb_Yvanguard3
    global xb_Yswift
    global yb_Yswift
    global xb_Yflyer1
    global yb_Yflyer1
    global xb_Yflyer2
    global yb_Yflyer2
    global xb_Ygoal
    global yb_Ygoal

    .c coords Gfencer $xb_Gfencer $yb_Gfencer
    .c coords Gblockader $xb_Gblockader $yb_Gblockader
    .c coords Glancer $xb_Glancer $yb_Glancer
    .c coords Gvanguard1 $xb_Gvanguard1 $yb_Gvanguard1
    .c coords Gvanguard2 $xb_Gvanguard2 $yb_Gvanguard2
    .c coords Gvanguard3 $xb_Gvanguard3 $yb_Gvanguard3
    .c coords Gswift $xb_Gswift $yb_Gswift
    .c coords Gflyer1 $xb_Gflyer1 $yb_Gflyer1
    .c coords Gflyer2 $xb_Gflyer2 $yb_Gflyer2
    .c coords Ggoal $xb_Ggoal $yb_Ggoal
    
    .c coords Yfencer $xb_Yfencer $yb_Yfencer
    .c coords Yblockader $xb_Yblockader $yb_Yblockader
    .c coords Ylancer $xb_Ylancer $yb_Ylancer
    .c coords Yvanguard1 $xb_Yvanguard1 $yb_Yvanguard1
    .c coords Yvanguard2 $xb_Yvanguard2 $yb_Yvanguard2
    .c coords Yvanguard3 $xb_Yvanguard3 $yb_Yvanguard3
    .c coords Yswift $xb_Yswift $yb_Yswift
    .c coords Yflyer1 $xb_Yflyer1 $yb_Yflyer1
    .c coords Yflyer2 $xb_Yflyer2 $yb_Yflyer2
    .c coords Ygoal $xb_Ygoal $yb_Ygoal
}


proc audience_init { sock } {
    global x_fact
    global y_fact

    set co [.c coords Gfencer]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Gfencer" $dx $dy

    set co [.c coords Gblockader]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Gblockader" $dx $dy

    set co [.c coords Glancer]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Glancer" $dx $dy

    set co [.c coords Gvanguard1]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Gvanguard1" $dx $dy

    set co [.c coords Gvanguard2]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Gvanguard2" $dx $dy

    set co [.c coords Gvanguard3]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Gvanguard3" $dx $dy

    set co [.c coords Gswift]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Gswift" $dx $dy

    set co [.c coords Gflyer1]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Gflyer1" $dx $dy

    set co [.c coords Gflyer2]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Gflyer2" $dx $dy

    set co [.c coords Ggoal]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Ggoal" $dx $dy


    set co [.c coords Yfencer]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Yfencer" $dx $dy

    set co [.c coords Yblockader]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Yblockader" $dx $dy

    set co [.c coords Ylancer]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Ylancer" $dx $dy

    set co [.c coords Yvanguard1]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Yvanguard1" $dx $dy

    set co [.c coords Yvanguard2]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Yvanguard2" $dx $dy

    set co [.c coords Yvanguard3]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Yvanguard3" $dx $dy

    set co [.c coords Yswift]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Yswift" $dx $dy

    set co [.c coords Yflyer1]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Yflyer1" $dx $dy

    set co [.c coords Yflyer2]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Yflyer2" $dx $dy

    set co [.c coords Ygoal]
    set dx [lindex $co 0]
    set dy [lindex $co 1]
    send_conn $sock "Ygoal" $dx $dy

    flush $sock
}


proc do_reinit {} {
    global sock_fd
    global connected

    if { $connected == 1 } {
	puts $sock_fd "RESET"
	flush $sock_fd
    }

    canvas_reinit
}


proc canvas_mark { tag x y w } {
    global canvas

    set coords [$w coords $tag]
    set canvas($w,obj) [$w find withtag $tag]
    set canvas($w,x) [expr $x - [lindex $coords 0]]
    set canvas($w,y) [expr $y - [lindex $coords 1]]
}


proc canvas_drag { tag x y w } {
    global sock_fd
    global canvas
    global connected
    global audience

    set obj [$w find withtag $tag]
#    set coords [$w coords $tag]

#    set oldx [lindex $coords 0]
#    set oldy [lindex $coords 1]
    set oldx $canvas($w,x)
    set oldy $canvas($w,y)

    set dx [expr $x - $oldx]
    set dy [expr $y - $oldy]
    $w coords $obj $dx $dy
    if { $connected == 1 } {
	send_conn $sock_fd "$tag" $dx $dy
	flush $sock_fd
    }
    if { $audience == 1 } {
	send_audience "$tag" $dx $dy
    }
#    set canvas($w,x) $x
#    set canvas($w,y) $y
}


proc talk_init { send } {
    global sock_fd
    global connected

    set w .t
    catch {destroy $w}
    toplevel $w

    frame $w.i
    frame $w.o

    pack $w.i $w.o -side top -fill both
    
    label $w.i.label -bd 4 -text "Type in the top box, you will see the other party's typing in the bottom box:"

    text $w.i.input -height 20 -width 60 -bd 2 -yscrollcommand "$w.i.scroll set"
    text $w.o.output -height 20 -width 60 -bd 2 -yscrollcommand "$w.o.scroll set" -state disabled
    pack $w.i.label -side top -fill x
    pack $w.i.input $w.o.output -side left -fill both
    scrollbar $w.i.scroll -command "$w.i.input yview"
    scrollbar $w.o.scroll -command "$w.o.output yview"
    pack $w.i.scroll -side right -fill y
    pack $w.o.scroll -side right -fill y
    bind $w.i.input <KeyPress> { send_talk_char %A }

    if { $connected == 1 && $send == 1 } {
	puts $sock_fd "ENABLETALK"
	flush $sock_fd
    }
}


proc send_conn { sock tag x y } {
    global size
    global x_fact
    global y_fact
    
    if { $size == "l" } {
	puts $sock "$tag $x $y"
    } else {
	set dx [expr $x * $x_fact]
	set dy [expr $y * $y_fact]
	puts $sock "$tag $dx $dy"
    }
}


proc send_audience { str x y } {
    global audience
    global a_fds

    foreach i $a_fds {
	send_conn $i "$str" $x $y
	flush $i
    }
}


proc talk_destroy { send } {
    global connected
    global sock_fd

    catch {destroy .t}

    if { $connected == 1 && $send == 1 } {
	puts $sock_fd "DISABLETALK"
	flush $sock_fd
    }
}


proc send_talk_char { c } {
    global sock_fd
    global talk_enabled
    global connected

    if { $talk_enabled == 1 && $connected == 1 } {
	puts $sock_fd "DT $c"
	flush $sock_fd
    }
}


proc talk_input { str } {
    global talk_enabled

    if { $talk_enabled == 1 } {
	.t.o.output configure -state normal
	if { $str == "\b" } {
	    .t.o.output delete "insert - 1 chars" end
	} else {
	    .t.o.output insert end $str
	}
	.t.o.output yview moveto 1
	.t.o.output configure -state disabled
    }
}


proc audience_input { sock } {
    global a_fds
    global canvas
    global connected
    global talk_enabled
    global audience

    set count [gets $sock line]
    if { $count < 0 } {
	catch {fileevent $sock readable}
	catch {close $sock}
	set i [lsearch -exact $a_fds $sock]
	set l1 [lrange $a_fds 0 [expr $i - 1]]
	set l2 [lrange $a_fds [expr $i + 1] end]

	set len1 [llength $l1]
	set len2 [llength $l2]

	if { $len1 == 0 && $len2 == 0 } {
	    set audience 0
	    set a_fds {}
	} elseif { $len1 == 0 } {
	    set a_fds $l2
	} elseif { $len2 == 0 } {
	    set a_fds $l1
	} else {
	    set a_fds [concat $l1 $l2]
	}
	return
    }
}

    
proc socket_input {} {
    global sock_fd
    global canvas
    global connected
    global talk_enabled
    global audience
    global size
    global x_fact
    global y_fact

    set count [gets $sock_fd line]
    set data [split $line " "]
    
    if { $count < 0 } {
	catch {fileevent $sock_fd readable}
	catch {close $sock_fd}
	error_box .c "Other side closed connection."
	set connected 0
	return
    }
    
    if { $line == "" } {
	talk_input "\n"
	return
    }
    
    set tag [lindex $data 0]

    if { $tag == "DT" } {
	talk_input [string range $line 3 end]
	return
    } elseif { $tag == "ENABLETALK" && $talk_enabled == 0 } {
	set answer [tk_messageBox -message "Other party requests you talk, enable it?" -type yesno -icon question]
	if { $answer == "no" } {
	    return
	}
	talk_init 0
	set talk_enabled 1
	return
    } elseif { $tag == "RESET" } {
        set answer [tk_messageBox -message "Other party requests reset, comply?" -type yesno -icon question]
        if { $answer == "no" } {
            return
        }
	canvas_reinit
        return
    } elseif { $tag == "DISABLETALK" && $talk_enabled == 1 } {
	set answer [tk_messageBox -message "Other party has closed talk, disable it?" -type yesno -icon question]
	if { $answer == "no" } {
	    return
	}
	talk_destroy 0
	set talk_enabled 0
	return
    }

    set dx [lindex $data 1]
    set dy [lindex $data 2]

    if { $size == "s" } {
	set dx [expr $dx / $x_fact]
	set dx [expr round($dx)]
	set dy [expr $dy / $y_fact]
	set dy [expr round($dy)]
    }
    
    if { $audience == 1 } {
	set tl [split $line]
	send_audience [lindex $tl 0] $dx $dy
    }

#    if { $audience == 1 } {
#	set tl [split $line]
#	send_audience [lindex $tl 0] [lindex $tl 1] [lindex $tl 2]
#    }

    set w .c

    set obj [$w find withtag $tag]
    $w coords $obj $dx $dy
}


proc bgerror { m } {
    global sock_fd
    
    error_box . $m
    catch {close $sock_fd}
    exit 1
}


proc socket_accept { name addr port } {
    global sock_fd
    global connected
    global a_fds
    global audience
    
    set count [gets $name line]

    if { $count <= 0 || $line == "" } {
	catch {close $name}
	return
    }
    
    if { $line == "PLAY" && $connected == 1 } {
	set answer [tk_messageBox -message "New incoming player connection. You must close the existing player connection to accept the new one. Close it and accept the new one?" -type yesno -icon question]
	if { $answer == "no" } {
	    puts $name "FAILED"
	    flush $name
	    catch {close $name}
	    return
	}
	catch {close $name}
	set connected 0
    } elseif { $line == "PLAY" } {
	set answer [tk_messageBox -message \
			"New incoming player connection. Accept it?" \
			-type yesno -icon question]
	if { $answer == "no" } {
	    puts $name "FAILED"
	    flush $name
	    catch {close $name}
	    return
	}
    } else {
	set answer [tk_messageBox -message \
			"New incoming audience member. Accept it?" \
			-type yesno -icon question]
	if { $answer == "no" } {
	    puts $name "FAILED"
	    flush $name
	    catch {close $name}
	    return
	}
    }

    if { $connected == 1 || $line == "WATCH" } {
	puts $name "OK"
	flush $name
	audience_init $name
	set audience 1
	set a_fds [lappend a_fds $name]
	fileevent $name readable "audience_input $name"
    } else {
	puts $name "OK"
	flush $name
	set sock_fd $name
	fileevent $sock_fd readable socket_input
	set connected 1
	set x [tk_messageBox -message "New incoming connection established." -type ok -icon info]
	canvas_reinit
    }
}


proc do_server_socket {} {
    global socket_type
    set socket_type "server"
}


proc do_client_socket {} {
    global socket_type
    set socket_type "client"
}


proc choose_socket_type {} {
    global socket_type

    set w .socktype
    catch {destroy $w}
    toplevel $w
    wm title $w "Choose Socket Type"
    wm iconname $w "Choose Socket Type"
    
    label $w.msg -wraplength 4i -justify left -text "Choose Socket Type\n"
    pack $w.msg -side top

    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    button $w.buttons.server -text "Listen for Connection" -command \
	{ do_server_socket }
    button $w.buttons.client -text "Initiate Connection" -command \
	{ do_client_socket }
    pack $w.buttons.server $w.buttons.client -side left -expand 1

    grab set $w

    tkwait variable socket_type

    destroy $w

    return $socket_type
}    


proc get_remote_address {} {
    global addr

    set w .address
    catch {destroy $w}
    toplevel $w
    wm title $w "Connect To:"
    wm iconname $w "Connect To:"
    
    label $w.msg -wraplength 4i -justify left -text "Connect To:\n"
    pack $w.msg -side top

    frame $w.buttons
    pack $w.buttons -side bottom -fill x -pady 2m
    button $w.buttons.connect -text "Connect" -command \
	{ global addr; set addr [.address.box.entry get] }
    button $w.buttons.cancel -text "Cancel" -command \
	{ global addr; set addr "" }
    pack $w.buttons.connect $w.buttons.cancel -side left -expand 1

    frame $w.box
    pack $w.box -side top -fill x -pady 2m
    label $w.box.l -text "Host or IP:" -justify right
    entry $w.box.entry -width 40
    pack $w.box.l $w.box.entry -side left

    grab set $w

    focus $w.box.entry

    tkwait variable addr

    destroy $w

    return $addr
}    


proc connect_host {} {
    global sock_fd
    global connected

    if { $connected == 1 } {
	set answer [tk_messageBox -message "You are already connected. Close connection?" -type yesno -icon question]
	if { $answer == "no" } {
	    return
	}
	catch {close $sock_fd}
    }
    
    set address [get_remote_address]
    
    if { $address == "" } {
	return
    }
    
    if { [catch {socket $address 5159} sock_fd] } {
	error_box .c "Can't connect to the other party."
	return
    }

    puts $sock_fd "PLAY"
    flush $sock_fd

    set count [gets $sock_fd line]
    
    if { $count <= 0 || $line != "OK" } {
	set x [tk_messageBox -message "Connection rejected." \
		   -type ok -icon info]
	set sock_fd ""
	set connected 0
	return
    }
    
    fileevent $sock_fd readable socket_input
    set connected 1
    set x [tk_messageBox -message "Connection established." -type ok -icon info]
    canvas_reinit
}

proc watch_game {} {
    global sock_fd
    global connected
    global in_audience

    set address [get_remote_address]
    
    if { $address == "" } {
	return
    }
    
    if { [catch {socket $address 5159} sock_fd] } {
	error_box .c "Can't connect to the other party."
	return
    }
    
    puts $sock_fd "WATCH"
    flush $sock_fd
    
    set count [gets $sock_fd line]

    if { $count <= 0 || $line != "OK" } {
	set x [tk_messageBox -message "Connection rejected." \
		   -type ok -icon info]
	set sock_fd ""
	set connected 0
	return
    }
    
    fileevent $sock_fd readable socket_input
    set in_audience 1
    set x [tk_messageBox -message "Connection established." -type ok -icon info]
}

proc disconnect {} {
    global sock_fd
    global connected
    global in_audience

    if { $connected == 0 && $in_audience == 0 } {
	return
    }

    fileevent $sock_fd readable
    catch {close $sock_fd}
    set connected 0
    set x [tk_messageBox -message "Connection closed." -type ok -icon info]
}


proc listen_conn {} {
    global sock_fd
    global connected
    global listen_fd
    global listening

    if { $listening == 1 } {
	return
    }
    
    if { [catch {socket -server socket_accept 5159} listen_fd] } {
	error_box .c "Can't listen to the socket."
	return
    }
    set x [tk_messageBox -message "Listening for connections enabled." -type ok -icon info]
    set listening 1
}


proc stop_listen_conn {} {
    global sock_fd
    global connected
    global listen_fd
    global listening

    if { $listening == 1 } {
	catch {close $listen_fd}
	
	set x [tk_messageBox -message "Listening for connections disabled." -type ok -icon info]
	set listening 0
    }
}


proc switch_talk {} {
    global talk_enabled

    if { $talk_enabled == 1 } {
	talk_init 1
    } else {
	talk_destroy 1
    }
}


proc switch_listen {} {
    global do_listen

    if { $do_listen == 0 } {
	stop_listen_conn
    } else {
	listen_conn
    }
}


set screen_size [wm maxsize .]
if { [lindex $screen_size 0] < 700 } {
    set size s
    set img_p s
    set x_fact 1.25
    set y_fact 1.25
} else {
    set size l
    set img_p l
    set x_fact 1
    set y_fact 1
}

# For testing, ignore
#set size s
#set img_p s
#set x_fact 1.25
#set y_fact 1.25


#
# Load Images
#
set t $img_p
image create photo Gfencer -file [append t "Gfencer.gif"]
set t $img_p
image create photo Gblockader -file [append t "Gblockader.gif"]
set t $img_p
image create photo Glancer -file [append t "Glancer.gif"]
set t $img_p
image create photo Gvanguard -file [append t "Gvanguard.gif"]
set t $img_p
image create photo Gswift -file [append t "Gswift.gif"]
set t $img_p
image create photo Gflyer -file [append t "Gflyer.gif"]
set t $img_p
image create photo Ggoal -file [append t "Ggoal.gif"]

set t $img_p
image create photo Yfencer -file [append t "Yfencer.gif"]
set t $img_p
image create photo Yblockader -file [append t "Yblockader.gif"]
set t $img_p
image create photo Ylancer -file [append t "Ylancer.gif"]
set t $img_p
image create photo Yvanguard -file [append t "Yvanguard.gif"]
set t $img_p
image create photo Yswift -file [append t "Yswift.gif"]
set t $img_p
image create photo Yflyer -file [append t "Yflyer.gif"]
set t $img_p
image create photo Ygoal -file [append t "Ygoal.gif"]

set t $img_p
image create photo Board -file [append t "board.gif"]


#
# Build Menus
#
menu .menu -tearoff 0

set m .menu.file
menu $m -tearoff 0
.menu add cascade -label "Commands" -menu $m -underline 0
$m add command -label "Connect To Host..." -command { connect_host }
$m add command -label "Watch Game..." -command { watch_game }
$m add command -label "Disconnect" -command { disconnect }
$m add separator
$m add checkbutton -label "Listen for Connections" -variable do_listen \
    -command { switch_listen }
#$m add separator
#$m add checkbutton -label "Enable Talk" -variable talk_enabled -command { switch_talk }
$m add separator
$m add command -label "Reset Board" -command { do_reinit }
$m add command -label "Quit" -command { exit 0 }

. configure -menu .menu

set talk_enabled 0
set connected 0
set audience 0
set in_audience 0
set listening 0
set do_listen 0
set a_fds {}

canvas_init




